#include <vector>
#include "Node.h"
#include "Lan.h"
#include "Workstation.h"
#include "PrintServer.h"
#include "Packet.h"
#include "PacketFactory.h"

int main()
{

  // una packet factory, comune a tutti i nodi
  // anche instanziandone un'altra non vi
  // saranno partizionamenti della lan, grazie
  // al singleton pattern
  PacketFactory* pf = PacketFactory::instance();
  
  vector< Node * > vectorNodes;
  Node *n1 = new Workstation( "pc01", pf );
  Node *n2 = new Workstation( "pc02", pf );
  Node *n3 = new Workstation( "pc03", pf );
  Node *n4 = new Workstation( "pc04", pf );
  Node *n5 = new Workstation( "pc05", pf );
  Node *n6 = new PrintServer( "Xerox PS", pf, "PostScript");
  Node *n7 = new PrintServer( "Canon", pf);
  
  vectorNodes.push_back( n1 );
  vectorNodes.push_back( n2 );
  vectorNodes.push_back( n3 );
  vectorNodes.push_back( n4 );
  vectorNodes.push_back( n5 );
  vectorNodes.push_back( n6 );
  vectorNodes.push_back( n7 );
  
  //cout << "Dimensione " << vectorNodes.size() << endl;
  
  Lan *mylan = new Lan( 10,  vectorNodes );

  Node *n8 = new PrintServer( "hewlett packard", pf, "ASCII");

  mylan->addNode( n8 );

  for (int i=0; i < 100; i++) 
     mylan->doWork();
  cout << "Banda disponibile " << mylan->bandWidth() << endl;
  
   
  delete mylan;
  delete pf;

  return 0;  
}
